program AR_extractor;

{$APPTYPE CONSOLE}

uses
	Windows, SysUtils, Graphics;

const
	IMAGE_PACKAGE = 'image.dat';
var
	nImage : integer = 0;
	ImageOffset : array[1..100] of integer;


procedure LoadBitmap;
var
	pf: file;
	wImage, hImage : word;
	index : integer;
	FileName : ShortString;
begin
	AssignFile(pf, IMAGE_PACKAGE);
{$I-}
	Reset(pf, 1);
{$I+}
	if IOResult <> 0 then
		Exit;

	nImage := 0;

	while not eof(pf) do begin
		inc(nImage);

		ImageOffset[nImage] := FilePos(pf);

		BlockRead(pf, wImage, 2);
		BlockRead(pf, hImage, 2);

		index := 0;
		repeat
			inc(index);
			BlockRead(pf, FileName[index], 1);
		until FileName[index] = chr(0);

		FileName[0] := chr(0);

		Seek(pf, FilePos(pf) + wImage * hImage * 2);
	end;

	CloseFile(pf);
end;

procedure ReadBitmap(ixframe : integer);
var
	pf       : file;
	i        : integer;

	wImage,
	hImage   : word;
	FileName : ShortString;

	Bitmap   : TBitmap;
	pBuffer  : PWORD;
	pSour,
	pDest    : PWORD;
begin
	if not (ixFrame in [1..nImage]) then
		Exit;

	AssignFile(pf, IMAGE_PACKAGE);
{$I-}
	Reset(pf, 1);
{$I+}
	if IOResult <> 0 then
		Exit;

	Seek(pf, ImageOffset[ixframe]);

	BlockRead(pf, wImage, 2);
	BlockRead(pf, hImage, 2);

	i := 0;
	repeat
		inc(i);
		BlockRead(pf, FileName[i], 1);
	until FileName[i] = chr(0);

	FileName[0] := chr(i-1);

	pBuffer := AllocMem(wImage * hImage * 2);
	BlockRead(pf, pBuffer^, wImage * hImage * 2);

	CloseFile(pf);

	// Bitmap ó
	Bitmap := TBitmap.Create;

	Bitmap.Width := wImage;
	Bitmap.Height := hImage;
	Bitmap.PixelFormat := pf15Bit;

	for i := 0 to pred(hImage) do begin
		pSour := PWORD(LongInt(pBuffer) + wImage * i * 2);
		pDest := Bitmap.ScanLine[i];

		Move(pSour^, pDest^, wImage * 2);
	end;

	FreeMem(pBuffer);

	Bitmap.SaveToFile(FileName);

	Bitmap.Free;
end;

var
	i : integer;
begin
	LoadBitmap;

	WriteLn('Image.dat contains ', nImage, ' bitmaps.');

	for i := 1 to nImage do begin
		WriteLn('processing #', i, '/', nImage);
		ReadBitmap(i);
	end;

	WriteLn('Done.');
end.

